/*
 * VCNL4035X01_Application_Library.h
 *
 * Created  : 9 November 2020
 * Modified : 1 February 2021
 * Author   : HWanyusof
 * Version  : 4
 */
 
#include "typedefinition.h"


//Determine Sensitivity From ALS IT
/*VCNL4035X01_CAL_Sensitivity(Byte ALS_IT)
*Byte ALS_IT - Input Parameter:
VCNL4035X01_ALS_IT_50MS
VCNL4035X01_ALS_IT_100MS
VCNL4035X01_ALS_IT_200MS
VCNL4035X01_ALS_IT_400MS
VCNL4035X01_ALS_IT_800MS
*/
float VCNL4035X01_CAL_Sensitivity(Byte ALS_IT);

//Calculate the Als (Lux)
/*VCNL4035X01_CAL_Lux(float Sensitivity, float Count)
*float Sensitivity - output from VCNL4035X01_CAL_Sensitivity(Byte ALS_IT)
*float Count - output from VCNL4035X01_GET_ALS_Data()
*/
float VCNL4035X01_CAL_Lux(float Sensitivity, float Count);


//Get Delay for Measurement
/*VCNL4035X01_VCNL4035X01_GET_Delay(Byte ALS_IT)
*Byte ALS_IT - Input Parameter:
VCNL4035X01_ALS_IT_50MS
VCNL4035X01_ALS_IT_100MS
VCNL4035X01_ALS_IT_200MS
VCNL4035X01_ALS_IT_400MS
VCNL4035X01_ALS_IT_800MS
*/
int VCNL4035X01_VCNL4035X01_GET_Delay(Byte ALS_IT);

//Reset the Sensor to the default value
void Reset_Sensor();

//Print the Register Value (Only supported for PSoc Cypress, STM32 and Arduino supported MCU)
/*Print_Sensor(char mode_ps,char mode_als,Byte ALS_IT)
*char mode_ps - Input Parameter:
*'A'
*'S'
*'G'
*
*char mode_als - Input Parameter:
*'L'
*'W'
*
*Byte ALS_IT - Input Parameter:
VCNL4035X01_ALS_IT_50MS
VCNL4035X01_ALS_IT_100MS
VCNL4035X01_ALS_IT_200MS
VCNL4035X01_ALS_IT_400MS
VCNL4035X01_ALS_IT_800MS
*/
void Print_Sensor(char mode_ps,char mode_als,Byte ALS_IT);

//Reverses a string 'str' of length 'len'
/*reverse(char* str, int len)
*char* str - Array pointer to be reversed
*int len - Length of the array
*/
void reverse(char* str, int len);

//Converts a given integer x to string str[].
/*intToStr(int x, char str[], int d)
*int x - floating-point number to be converted to a string (Both the integer part as well as fraction/decimal point part)
*char str[] - output string of the floating-point number in the form of array character
*int d - number of decimal point (the integer part always = 0, the fraction/decimal point part = int afterpoint from ftoa() input)
*/
int intToStr(int x, char str[], int d);

//Converts a floating-point/double number to string.
/*ftoa(float n, char* res, int afterpoint)
*float n - floating-point number to be converted to a string
*char* res - pointer to output string of the floating-point number in the form of array character
*int d - number of decimal point
*/
void ftoa(float n, char* res, int afterpoint);
